/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.core.util;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.util.LoggerUtil;
import jp.co.ntt.lms.installer.util.StringUtil;

/**
 * ファイルに関連するユーティリティ・クラス。
 * @author T.Nishiki
 */
public class InstallerProcessUtil {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。<br>
	 * ログ出力オブジェクトを取得します。
	 */
	static {
		_logger = LoggerUtil.getLogger(InstallerProcessUtil.class);
	}

	/**
	 * コマンドを実行します。<br>
	 * @param commandArray 実行するコマンド配列。<br>
	 * @throws InstallerException
	 *          実行中にエラーが発生した場合。
	 *          実行したコマンドから０以外が返却され、かつthrowNonZeroがtrueの場合。
	 */
	public static void excuteCommands(String[] commandArray)
		throws InstallerException {
		// メソッド開始ログ
		String logMessage = null;
		if (LoggerUtil.isLoggableMethod(_logger)) {
			logMessage = "excuteCommands("
				+  StringUtil.toString(commandArray) + ")";
			LoggerUtil.methodHead(_logger, logMessage );
		}


		BufferedReader errorReader = null;
		BufferedReader outReader = null;
		boolean successFlag = false;
		try {
			// コマンド実行
			Runtime runtime = Runtime.getRuntime();
			Process process = runtime.exec(commandArray);
			int exitValue = process.waitFor();
			// 標準出力を取得してログ出力
			outReader = new BufferedReader(
							new InputStreamReader(process.getInputStream()));
			for (int i = 0; true; i++) {
				String line = outReader.readLine();
				if (line == null) {
					break;
				}
				_logger.info("[" + i + "][" + line + "]");
			}
			// エラーコードが戻された場合、例外スロー
			if (exitValue != 0) {
				// 標準エラー出力を取得してログ出力
				errorReader = new BufferedReader(
								new InputStreamReader(
									process.getErrorStream()));
				for (int i = 0; true; i++) {
					String line = errorReader.readLine();
					if (line == null) {
						break;
					}
					_logger.warning("[" + i + "][" + line + "]");
				}
				throw new InstallerException("EXIT CODE:" + exitValue);
			}
			// tryブロック終端まで到達したので成功扱い
			successFlag = true;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		finally {
			InstallerException thrown = null;
			try {
				InstallerFileUtil.close(errorReader, successFlag);
			}
			catch (InstallerException ie) {
				thrown = ie;
			}
			try {
				InstallerFileUtil.close(outReader, successFlag);
			}
			catch (InstallerException ie) {
				if (thrown == null) {
					thrown = ie;
				}
			}
			if (thrown != null) {
				throw thrown;
			}
		}
		if (LoggerUtil.isLoggableMethod(_logger)) {
			LoggerUtil.methodTail(_logger, logMessage);
		}
	}
}
